#include <rros2protocol.h>

#include <stdlib.h>
#include <sys/time.h>
#include <sys/select.h>
#include <strings.h>

RROS2_MESSAGE *RROS2_NewMessage()
{
	RROS2_MESSAGE *NewMsg;

	NewMsg=new RROS2_MESSAGE;
	NewMsg->Request=0;
	NewMsg->Response=0;
	NewMsg->Position=0;
	NewMsg->Space=1024;
	NewMsg->Position=0;

	return NewMsg;
}

RROS2_MESSAGE *RROS2_Transcieve(int sock, RROS2_MESSAGE *outmsg)
{
	RROS2_MESSAGE *NewMsg;
	int rc, sunlen;
	struct sockaddr_un sun;
	fd_set fds;
	struct timeval to;

	if (sock==-1 || !outmsg || outmsg->Position>1024)
		return NULL;

	sun.sun_family=AF_UNIX;
	strcpy(sun.sun_path,"\\socket\\rros2");
	rc=sendto(sock,(char *)outmsg,RROS2_HEADER_SIZE+outmsg->Position,0,(sockaddr *)&sun,sizeof(sun));
	if (rc!=RROS2_HEADER_SIZE+outmsg->Position)
		return NULL;

	NewMsg=new RROS2_MESSAGE;
	FD_ZERO(&fds);
	FD_SET(sock,&fds);
	to.tv_sec=5;
	to.tv_usec=0;
	rc=select(sock+1,&fds,NULL,NULL,&to);
	if (rc<1)
	{
		delete NewMsg;
		return NULL;
	}
	sunlen=sizeof(sun);
	rc=recvfrom(sock,(char *)NewMsg,sizeof(RROS2_MESSAGE),0,(struct sockaddr *)&sun,&sunlen);
	if (rc<RROS2_HEADER_SIZE || rc<RROS2_HEADER_SIZE+NewMsg->Position)
	{
		delete NewMsg;
		return NULL;
	}

	NewMsg->Space=NewMsg->Position;
	NewMsg->Position=0;

	return NewMsg;
}

int RROS2_AddString(RROS2_MESSAGE *Message, char *String)
{
	int len;

	if (!Message || !String || 4+(len=strlen(String)+1)>Message->Space-Message->Position+1)
		return -1;

	*(int *)(Message->Payload+Message->Position)=len;
	Message->Position+=4;
	strcpy(Message->Payload+Message->Position,String);
	Message->Position+=len;

	return 0;
}

int RROS2_AddInt(RROS2_MESSAGE *Message, int Integer)
{
	if (!Message || 8>Message->Space-Message->Position+1)
		return -1;

	*(int *)(Message->Payload+Message->Position)=4;
	Message->Position+=4;
	*(int *)(Message->Payload+Message->Position)=Integer;
	Message->Position+=4;

	return 0;
}

int RROS2_GetString(RROS2_MESSAGE *Message, char **pString)
{
	int len;

	if (!Message || !pString || Message->Position+4>=Message->Space)
		return -1;

	len=*(int *)(Message->Payload+Message->Position);
	Message->Position+=4;
	
	if (len>Message->Space-Message->Position || Message->Payload[Message->Position+len-1])
		return -2;

	*pString=Message->Payload+Message->Position;
	Message->Position+=len;

	return 0;
}

int RROS2_GetInt(RROS2_MESSAGE *Message, int *pInteger)
{
	int len;

	if (!Message || !pInteger || Message->Position+4>=Message->Space)
		return -1;

	len=*(int *)(Message->Payload+Message->Position);
	Message->Position+=4;
	
	if (len!=4 || len>Message->Space-Message->Position)
		return -2;

	*pInteger=*(int *)(Message->Payload+Message->Position);
	Message->Position+=len;

	return 0;
}

